# rtc_mini.py
# Support for ds3231 real-time clock
# Version July 19, 2019

_addr = 0x68
from calliope_mini import i2c

def dec2bcd(dec):
    tens, units = divmod(dec, 10)
    return (tens << 4) + units

def bcd2dec(bcd):
    return ((bcd & 0xf0) >> 4) * 10 + (bcd & 0x0f)

def set(*args):
    if len(args) == 1:
        t = bytes([args[0][5], args[0][4], args[0][3], args[0][6], args[0][2], args[0][1], args[0][0] - 2000])
    else:
        t = bytes([args[5], args[4], args[3], args[6], args[2], args[1], args[0] - 2000])
    for i in range(0,7):
        i2c.write(_addr, bytes([i, dec2bcd(t[i])]))

def get():
    i2c.write(_addr, b'\x00')
    buf = i2c.read(_addr, 7)
    s = bcd2dec(buf[0])
    m = bcd2dec(buf[1])
    if buf[2] & 0x40:
        h = bcd2dec(buf[2] & 0x1f)
        if buf[2] & 0x20:
            h += 12
    else:
        h = bcd2dec(buf[2])
    w = buf[3]
    dd = bcd2dec(buf[4])
    mm = bcd2dec(buf[5] & 0x1f)
    yy = bcd2dec(buf[6]) + 2000
    return yy, mm, dd, h, m, s, w
